import tagApplyApi from '@@/api/TagApplyApi'

import DataTimeRange from '@@/utils/DataTimeRange'

import BaseCurdEntry from './BaseCurdEntry'
import TagApplyState from './TagApplyState'
import Provider from './Provider'

export default class TagApply extends BaseCurdEntry {
  id

  dataTime
  get formatDataTime () {
    return new Date(this.dataTime).format('YYYY-MM-DD')
  }

  orderNo

  expectedReceiptDate
  get formatExpectedReceiptDate () {
    return new Date(this.expectedReceiptDate).format('YYYY-MM-DD')
  }

  providerId
  get providerName () {
    const config = TagApply.$$optionData.Provider
    if (config) {
      const option = config.map[this.providerId]
      if (option) {
        return option[Provider.$$nameProp]
      }
    }

    return ''
  }

  materielCode

  goodsCode

  goodsName

  tagTypeName

  minimumPackingUnit

  number

  amount

  tagApplyStateId
  get tagApplyStateName () {
    const config = TagApply.$$optionData.TagApplyState
    if (config) {
      const option = config.map[this.tagApplyStateId]
      if (option) {
        return option[TagApplyState.$$nameProp]
      }
    }

    return ''
  }

  operatorName

  applicantName

  unitPrice

  cTime
  get formatCreateTime () {
    return new Date(this.cTime).format('YYYY-MM-DD')
  }

  get subtotal () {
    return this.amount
  }

  static get $$name () {
    return 'TagApply'
  }

  static get $$api () {
    return tagApplyApi
  }

  static $$getQuery = () => ({
    ...(new DataTimeRange({
      unit: 'Date',
      diff: 7,
      offset: 0
    })),
    providerId: '',
    tagApplyStateId: '',
    order: [['dataTime', 'DESC']]
  })

  static $$optionTargetConfigGroup = [
    [{
      Target: TagApplyState,
      getQuery: () => ({type: 1}),
      setQuery: (options, query, Target) => {
        const [ option ] = options
        if (option) {
          query.tagApplyStateId = option[Target.$$idProp]
        }
      }
    }, {
      Target: Provider,
      setQuery: (options, query, Target) => {
        const [ option ] = options
        if (option) {
          query.providerId = option[Target.$$idProp]
        }
      }
    }]
  ]
  static $$optionData = {}
}
